# taken from Python 3 stdlib
class Generator(object):
    def __iter__(self):
        return self

    def next(self):
        return self.__next__()

    def throw(self, typ, val=None, tb=None):
        if val is None:
            if tb is None:
                raise typ
            val = typ()
        if tb is not None:
            val = val.with_traceback(tb)
        raise val

    def close(self):
        try:
            self.throw(GeneratorExit)
        except (GeneratorExit, StopIteration):
            pass
        else:
            raise RuntimeError('generator ignored GeneratorExit')
